#include<iostream>
#include<conio>
#include<sys\timeb>
#include<stdlib>

#pragma hdrstop
#include"TVDStree.h"

int** matrix;
int dimension;
int delay = 0;
int Faktor;

// ================================================================= Entwicklungs Reihenfolge
template<class T> inline void swap(T& a, T& b)
   {
   T swap = a;
   a = b;
   b = swap;
   }

int* reihenfolge;
int* anzahl;

int* LPanzahl;
int* LPanzahlS;
int** LPposZEROS;

int Bestimme_Reihenfolge()
   {
   int faktor = 1;
   for(int i = 0; i < dimension; i++)
      {
      anzahl[i] = 0;
      LPanzahl[i] = 0;
      LPanzahlS[i] = 0;
      reihenfolge[i] = i;
      }
   for(int i = 0; i < dimension; i++)
      for(int j = 0; j < dimension; j++)
         if(matrix[i][j] == 0)
            {
            anzahl[i]++;
            LPanzahl[i]++;
            LPposZEROS[LPanzahlS[j]++][j] = i;
            }
   for(int i = 1; i < dimension; i++)
      for(int j = 0; j < dimension - i; j++)
         if(anzahl[j] < anzahl[j+1])
            {
            int swap = anzahl[j];
            anzahl[j] = anzahl[j+1];
            anzahl[j+1] = swap;
            swap = reihenfolge[j];
            reihenfolge[j] = reihenfolge[j+1];
            reihenfolge[j+1] = swap;
            faktor *= -1;
            }
   return(faktor);
   }

// ===================================================================================== TVDS
struct timeb TVDS_s, TVDS_e;
bool* spalten;
long double TVDS_cuts;
long double TVDS_reks;
long double TVDS_zerocuts;
int TVDS_erg;
TVDS_tree* calculated = NULL;
int TVDS(int rekdepth = 0)
   {
   int ret = 0;
   ftime(&TVDS_e);                                  // bisherige Dauer berechnen und anzeigen
   long TVDS_msec = (TVDS_e.time*1000+TVDS_e.millitm) - (TVDS_s.time*1000+TVDS_s.millitm);
   long TVDS_min = TVDS_msec/60000;
   TVDS_msec -= TVDS_min*60000;
   long TVDS_sec = TVDS_msec/1000;
   TVDS_msec -= TVDS_sec*1000;
   textcolor(0);
   gotoxy(68,15);
   cprintf("%02i:%02i,%1i",TVDS_min,TVDS_sec,TVDS_msec/100);

   TVDS_tree* leaf = findleaf(calculated, spalten);                               // TVDS-Cut
   if(leaf->content != NULL)
      {
      gotoxy(6,17);                                     // bekanntes n-Tupel in grn ausgeben
      textcolor(10);
      for(int i = 0; i < dimension; i++)
         cprintf("   %i ", spalten[i]);
      gotoxy(66,17);                   // bisherige Anzahl der TVDS-Cuts erhhen und anzeigen
      cout.width(9);
      cout << ++TVDS_cuts;
      for(int d = delay; d > 1; d--) for(int d = delay; d > 1; d--);
      return(*(leaf->content));
      }

   gotoxy(6,17);                                       // unbekanntes n-Tupel in rot ausgeben
   textcolor(4);
   for(int i = 0; i < dimension; i++)
      cprintf("   %i ", spalten[i]);
   gotoxy(66,16);              // bisherige Anzahl der Rekursionsaufrufe erhhen und anzeigen
   cout.width(9);
   cout << ++TVDS_reks;
   for(int d = delay; d > 1; d--) for(int d = delay; d > 1; d--);

   if(rekdepth == dimension-2)             // falls 2x2 Unterdeterminante: explizit berechnen
      {
      int sa,sb,za,zb;
      for(sa = 0; sa < dimension; sa++)
         if(spalten[sa])
            break;
      for(sb = sa+1; sb < dimension; sb++)
         if(spalten[sb])
            break;
      za = reihenfolge[dimension-2];
      zb = reihenfolge[dimension-1];
      ret = matrix[za][sa] * matrix[zb][sb] - matrix[za][sb] * matrix[zb][sa];
      leaf->content = new(int);
      *(leaf->content) = ret;
      return(ret);
      }

   int z = reihenfolge[rekdepth];
   textcolor(8);;
   for(int j = 0; j < dimension; j++)       // gestrichene Zeile auf dem Bildschirm markieren
      if(spalten[j])
         {
         gotoxy(5*j+7,z+5);
         cprintf("%3i", matrix[z][j]);
         }

   int faktor = -1;
   for(int i = 0; i < dimension; i++)
      if(spalten[i])
         {
         faktor *= -1;

         if(matrix[z][i] != 0)
            {
            spalten[i] = false;                                           // Spalte streichen
            textcolor(12);                 // gestrichene Spalte auf dem Bildschirm markieren
            gotoxy(5*i+7,z+5);
            cprintf("%3i", matrix[z][i]);
            textcolor(8);;
            for(int j = rekdepth+1; j < dimension; j++)
               {
               gotoxy(5*i+7,reihenfolge[j]+5);
               cprintf("%3i", matrix[reihenfolge[j]][i]);
               }

            ret += faktor * matrix[z][i] * TVDS(rekdepth+1);                     // Rekursion

            spalten[i] = true;                                            // Spalte freigeben
            textcolor(0);                 // freigegebene Spalte auf dem Bildschirm markieren
            for(int j = rekdepth+1; j < dimension; j++)
               {
               gotoxy(5*i+7,reihenfolge[j]+5);
               cprintf("%3i", matrix[reihenfolge[j]][i]);
               }
            textcolor(8);;
            gotoxy(5*i+7,z+5);
            cprintf("%3i", matrix[z][i]);
            }
         else
            {
            gotoxy(66,18);             // bisherige Anzahl der Zero-Cuts erhhen und anzeigen
            cout.width(9);
            cout << ++TVDS_zerocuts;
            }

         }

   textcolor(0);                           // freigegebene Zeile auf dem Bildschirm markieren
   for(int j = 0; j < dimension; j++)
      if(spalten[j])
         {
         gotoxy(5*j+7,z+5);
         cprintf("%3i", matrix[z][j]);
         }

   gotoxy(6,17);                                // fertig bestimmtes n-Tupel in blau ausgeben
   textcolor(9);
   for(int i = 0; i < dimension; i++)
      cprintf("   %i ", spalten[i]);
   for(int d = delay; d > 1; d--) for(int d = delay; d > 1; d--);

   leaf->content = new(int);
   *(leaf->content) = ret;                             // fertig bestimmtes n-Tupel speichern
   return(ret);                                           // (Unter-)Determinante zurckgeben
   }
// ================================================================================== Laplace
struct timeb LP_s,LP_e;
bool* LPspalten;
bool* LPzeilen;
long double LP_reks;
long double LP_zerocuts;
int LP_erg;
int Laplace(int rekdepth = 0)
   {
   int ret = 0;
   ftime(&LP_e);                                    // bisherige Dauer berechnen und anzeigen
   long LP_msec = (LP_e.time*1000+LP_e.millitm) - (LP_s.time*1000+LP_s.millitm);
   long LP_min = LP_msec/60000;
   LP_msec -= LP_min*60000;
   long LP_sec = LP_msec/1000;
   LP_msec -= LP_sec*1000;
   textcolor(0);
   gotoxy(68,6);
   cprintf("%02i:%02i,%1i",LP_min,LP_sec,LP_msec/100);

   gotoxy(66,7);               // bisherige Anzahl der Rekursionsaufrufe erhhen und anzeigen
   cout.width(9);
   cout << ++LP_reks;

   gotoxy(6,21);
   textcolor(0);
   for(int i = 0; i < dimension; i++)
      cprintf("   %i ", LPanzahl[i]);
   for(int d = delay; d > 1; d--) for(int d = delay; d > 1; d--);

   if(rekdepth == dimension-2)                  // falls 2x2 Determinante: explizit berechnen
      {
      int sa,sb,za,zb;
      for(sa = 0; sa < dimension; sa++) if(LPspalten[sa]) break;
      for(sb = sa+1; sb < dimension; sb++) if(LPspalten[sb]) break;
      for(zb = dimension-1; zb >= 0; zb--) if(LPzeilen[zb]) break;
      for(za = zb-1; za >= 0; za--) if(LPzeilen[za]) break;
      return(matrix[za][sa] * matrix[zb][sb] - matrix[za][sb] * matrix[zb][sa]);
      }

   int z=0, max=-1,gestrzeilen=0,gestrzeilentemp=0;
   for(int i = 0; i < dimension; i++)
      if(LPzeilen[i])
         {
         if(anzahl[i] > max)
            {
            z = i;
            max = anzahl[i];
            gestrzeilen = gestrzeilentemp;
            }
         }
      else
         gestrzeilentemp++;

   LPzeilen[z] = false;
   textcolor(8);;                           // gestrichene Zeile auf dem Bildschirm markieren
   for(int j = 0; j < dimension; j++)
      if(LPspalten[j])
         {
         gotoxy(5*j+7,z+5);
         cprintf("%3i", matrix[z][j]);
         }

   int faktor = -1+2*((z-gestrzeilen+1)%2);
   for(int s = 0; s < dimension; s++)
      if(LPspalten[s])
         {
         if(matrix[z][s] != 0)
            {
            for(int t = LPanzahlS[s]-1; t >= 0; t--)
               LPanzahl[LPposZEROS[t][s]]--;

            LPspalten[s] = false;
            textcolor(8);                     // gestrichene Spalte auf dem Bildschirm markieren
            for(int j = 0; j < dimension; j++)
               if(LPzeilen[j])
                  {
                  gotoxy(5*s+7,j+5);
                  cprintf("%3i", matrix[j][s]);
                  }
            textcolor(12);
            gotoxy(5*s+7,z+5);
            cprintf("%3i", matrix[z][s]);

            ret += (faktor * matrix[z][s] * Laplace(rekdepth+1));

            LPspalten[s] = true;
            textcolor(0);                    // freigegebene Spalte auf dem Bildschirm markieren
            for(int j = 0; j < dimension; j++)
               if(LPzeilen[j])
                  {
                  gotoxy(5*s+7,j+5);
                  cprintf("%3i", matrix[j][s]);
                  }
            textcolor(8);
            gotoxy(5*s+7,z+5);
            cprintf("%3i", matrix[z][s]);

            textcolor(0);
            gotoxy(6,21);
            for(int i = 0; i < dimension; i++)
               cprintf("   %i ", LPanzahl[i]);
            for(int d = delay; d > 1; d--) for(int d = delay; d > 1; d--);

            for(int t = LPanzahlS[s]-1; t >= 0; t--)
               LPanzahl[LPposZEROS[t][s]]++;
            }
         else
            {
            gotoxy(66,8);                 // bisherige Anzahl der Zero-Cuts erhhen und anzeigen
            cout.width(9);
            cout << ++LP_zerocuts;
            }
         faktor *= -1;
         }

   LPzeilen[z] = true;
   textcolor(0);                           // freigegebene Zeile auf dem Bildschirm markieren
   for(int j = 0; j < dimension; j++)
      if(LPspalten[j])
         {
         gotoxy(5*j+7,z+5);
         cprintf("%3i", matrix[z][j]);
         }

   gotoxy(6,21);
   textcolor(0);
   for(int i = 0; i < dimension; i++)
      cprintf("   %i ", LPanzahl[i]);
   for(int d = delay; d > 1; d--) for(int d = delay; d > 1; d--);

   return(ret);                                           // (Unter-)Determinante zurckgeben
   }

// ===================================================================================== MAIN
#include<stdio>
#include<io>
void creatematrix(int,bool);
void destroymatrix();
void main()
   {
   textmode(BW80);
   _setcursortype(_NOCURSOR);
   textbackground(7);
   randomize();
   dimension = 4;
   int marker = 1;
   int maxvalue = 10;
   bool disablezeros = true;
   int delayidentifier = 0;

   gotoxy(80,25);
   cprintf("  ");
   gotoxy(1,1);                                                       // Hintergrund anzeigen
   textcolor(0);
 cprintf("                                                                                ");
 cprintf("       ͻ                                 ͻ               ");
 cprintf("    ͹ %ix%i Matrix ͹ Laplace ͻ    ",dimension,dimension);
 cprintf("      ͼ                                ͼ              ");
 cprintf("                                                                             ");
 cprintf("                                                    Dauer                    ");
 cprintf("                                                    Rekursionen              ");
 cprintf("                                                    Zero-Cuts                ");
 cprintf("                                                    Ergebnis                 ");
 cprintf("                                                                             ");
 cprintf("                                                    ͻ                 ");
 cprintf("                                                  ͹ TVDS ͹    ");
 cprintf("                                                    ͼ                 ");
 cprintf("      ͻ                                                ");
 cprintf("    ͹ Boole'sches %i-Tupel ͹  Dauer                    ",dimension);
 cprintf("      ͼ                       Rekursionen              ");
 cprintf("                                                    TVDS-Cuts                ");
 cprintf("      ͻ                  Zero-Cuts                ");
 cprintf("    ͹ Entwicklungs-Reihenfolge ͹  Ergebnis                 ");
 cprintf("      ͼ                                           ");
 cprintf("                                                                             ");
 cprintf("    ͹    ");
 cprintf("      dim=4  random  explicit  maxvalue=10  delays=0  zeros=0  GO!  exit      ");
 cprintf("    ͼ    ");
 cprintf("                                                                              ");
 creatematrix(maxvalue,disablezeros);
   for(;dimension != 1;)
      {
      TVDS_cuts = 0;
      TVDS_reks = 0;
      TVDS_zerocuts = 0;
      LP_reks = 0;
      LP_zerocuts = 0;

      if(marker == 8 || (marker > 0 && marker < 3))
         {
         gotoxy(7,23);
         textcolor((marker == 1)? 7 : 0); textbackground((marker == 1)? 0 : 7);
         cprintf(" dim=%1i ",dimension);
         }
      if(marker > 0 && marker < 4)
         {
         gotoxy(14,23);
         textcolor((marker == 2)? 7 : 0); textbackground((marker == 2)? 0 : 7);
         cprintf(" random ");
         }
      if(marker > 1 && marker < 5)
         {
         gotoxy(22,23);
         textcolor((marker == 3)? 7 : 0); textbackground((marker == 3)? 0 : 7);
         cprintf(" explicit ");
         }
      if(marker > 2 && marker < 6)
         {
         gotoxy(32,23);
         textcolor((marker == 4)? 7 : 0); textbackground((marker == 4)? 0 : 7);
         cprintf(" maxvalue=%2i ",maxvalue);
         }
      if(marker > 3 && marker < 7)
         {
         gotoxy(45,23);
         textcolor((marker == 5)? 7 : 0); textbackground((marker == 5)? 0 : 7);
         cprintf(" delays=%i ",delayidentifier);
         }
      if(marker > 4 && marker < 8)
         {
         gotoxy(55,23);
         textcolor((marker == 6)? 7 : 0); textbackground((marker == 6)? 0 : 7);
         cprintf(" zeros=%i ", !disablezeros);
         }
      if(marker > 5 && marker < 9)
         {
         gotoxy(64,23);
         textcolor((marker == 7)? 7 : 0); textbackground((marker == 7)? 0 : 7);
         cprintf(" GO! ");
         }
      if(marker == 1 || (marker > 6 && marker < 9))
         {
         gotoxy(69,23);
         textcolor((marker == 8)? 7 : 0); textbackground((marker == 8)? 0 : 7);
         cprintf(" exit ");
         }

      int extended;
      int key = getch();
      if(key == 77)
         {marker = (marker == 8) ? 1 : marker+1; continue;}
      if(key == 75)
         {marker = (marker == 1) ? 8 : marker-1; continue;}
      if(key == 80)
         {
         switch(marker)
            {
            case 1:
               destroymatrix();
               dimension = (dimension == 3) ? 9 : dimension - 1;
               creatematrix(maxvalue,disablezeros);

               textcolor(0);
               gotoxy(10,3);
               cprintf("%ix%i",dimension,dimension);
               gotoxy(22,15);
               cprintf("%i-",dimension);
               gotoxy(12,23);
               cout << dimension;
               break;
            case 4:
               maxvalue = (maxvalue == 5) ? 30 : maxvalue - 5;
               destroymatrix();
               creatematrix(maxvalue,disablezeros);
               break;
            case 5:
               delayidentifier = (delayidentifier == 0) ? 3 : delayidentifier - 1;
               delay = (delay == 0) ? 15000 : delay - 5000;
               break;
            case 6:
               disablezeros = !disablezeros;
               destroymatrix();
               creatematrix(maxvalue,disablezeros);
               break;
            }
         }
      if(key == 72)
         {
         switch(marker)
            {
            case 1:
               destroymatrix();
               dimension = (dimension == 9) ? 3 : dimension + 1;
               creatematrix(maxvalue,disablezeros);

               textcolor(0);
               gotoxy(10,3);
               cprintf("%ix%i",dimension,dimension);
               gotoxy(22,15);
               cprintf("%i-",dimension);
               gotoxy(12,23);
               cout << dimension;
               break;
            case 4:
               maxvalue = (maxvalue == 30) ? 5 : maxvalue + 5;
               destroymatrix();
               creatematrix(maxvalue,disablezeros);
               break;
            case 5:
               delayidentifier = (delayidentifier == 3) ? 0 : delayidentifier + 1;
               delay = (delay == 15000) ? 0 : delay + 5000;
               break;
            case 6:
               disablezeros = !disablezeros;
               destroymatrix();
               creatematrix(maxvalue,disablezeros);
               break;
            }
         }
      if(key == 13)
         {
         int i,j;
         switch(marker)
            {
            case 2:
               destroymatrix();
               creatematrix(maxvalue,disablezeros);
               break;
            case 3:
               _setcursortype(_NORMALCURSOR);
               for(i = 0; i < dimension; i++)
                  for(j = 0; j < dimension; j++)
                     {
                     gotoxy(5*j+7,i+5);
                     cout << "   ";
                     cin.ignore(1);
                     gotoxy(5*j+7,i+5);
                     cin >> matrix[i][j];
                     gotoxy(5*j+7,i+5);
                     cprintf("%3i",matrix[i][j]);
                     }
               _setcursortype(_NOCURSOR);
               break;
            case 7:
               delete(calculated);
               calculated = new(TVDS_tree);
               Faktor = Bestimme_Reihenfolge();         // Entwicklungs-Reihenfolge bestimmen
               gotoxy(6,21);
               textcolor(0);
               for(i = 0; i < dimension; i++)
                  cprintf("   %i ", reihenfolge[i]+1);

               ftime(&TVDS_s);
               do {
                  ftime(&TVDS_e);
                  } while((TVDS_e.time*1000+TVDS_e.millitm) - (TVDS_s.time*1000+TVDS_s.millitm) < 1000);

               ftime(&TVDS_s);                                                // TVDS starten
               TVDS_erg = TVDS();
               gotoxy(66,19);
               cout.width(9);
               cout << Faktor * TVDS_erg;

               ftime(&LP_s);                                               // Laplace starten
               LP_erg = Laplace();
               gotoxy(66,9);
               cout.width(9);
               cout << LP_erg;

               break;
            case 8:
               dimension = 1;
               break;
            }
         }
      if(key == 27)
         break;
      }
   destroymatrix();
   }

void creatematrix(int max, bool add)
   {
   matrix = new(int*[dimension]);                                     // Variablen generieren
   spalten = new(bool[dimension]);
   LPzeilen = new(bool[dimension]);
   LPspalten = new(bool[dimension]);
   reihenfolge = new(int[dimension]);
   anzahl = new(int[dimension]);
   LPanzahl = new(int[dimension]);
   LPanzahlS = new(int[dimension]);
   LPposZEROS = new(int*[dimension]);
   for(int i = 0; i < dimension; i++)
      {
      matrix[i] = new(int[dimension]);
      LPposZEROS[i] = new(int[dimension]);
      for(int j = 0; j < dimension; j++)
         {
         matrix[i][j] = random(max-add) + add;
         gotoxy(5*j+7,i+5);
         cprintf("%3i",matrix[i][j]);
         }
      spalten[i] = true;
      LPzeilen[i] = true;
      LPspalten[i] = true;
      anzahl[i] = 0;
      LPanzahl[i] = 0;
      LPanzahlS[i] = 0;
      }
   calculated = new(TVDS_tree);
   }
void destroymatrix()
   {
   textcolor(0);
   textbackground(7);
   gotoxy(10,7);                                                       // Hintergrund lschen
   textcolor(0);
   cprintf("   ");
   for(int i = 0; i < 9; i++)
      {
      gotoxy(6,5+i);
      cprintf("                                              ");
      }
   gotoxy(6,17);
   cprintf("                                              ");
   gotoxy(6,21);
   cprintf("                                              ");
   for(int i = 0; i < 9; i++)
      {
      gotoxy(66,(6+i) + 5*(i >= 4));
      cprintf("         ");
      }

   for(int i = 0; i < dimension; i++)                                       // Felder lschen
      delete(matrix[i]);
   delete(matrix);
   delete(spalten);
   delete(LPzeilen);
   delete(LPspalten);
   delete(calculated);
   delete(anzahl);
   delete(reihenfolge);
   }
